package com.soft.nio.connector.socket;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.nio.ByteBuffer;
import java.nio.channels.SelectionKey;
import java.nio.channels.Selector;
import java.nio.channels.SocketChannel;
import java.util.Iterator;
import java.util.Set;

import com.soft.nio.connector.core.ThreadPool;

public class SocketWorkThread implements Runnable {

	/** selector专门用来监听client是否有数据传过来，可读 **/
	protected Selector selector;
	protected boolean stop;

	protected SocketWorkThread() {
		try {
			selector = Selector.open();
			ThreadPool.getInstance().execute(this);
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	public void stop() {
		this.stop = true;
	}

	@Override
	public void run() {
		// TODO Auto-generated method stub
		// selector进入read，write非阻塞状态 不能用while(select()>0)循环
		// 没有数据会跳出循环
		try {
			while (!stop) {
				listener();
			}
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			System.out.println("读取关闭异常");
		}
	}

	/** 监听是否有数据可读取 **/
	protected void listener() throws IOException {
		SelectionKey selectionKey = null;
		try {
			if (selector.select(10L) > 0) {
				Set<SelectionKey> set = selector.selectedKeys();
				Iterator<SelectionKey> iterator = set.iterator();
				while (iterator.hasNext()) {
					selectionKey = (SelectionKey) iterator.next();
					iterator.remove();// 用一个清除一个
					readBufer(selectionKey);
				}
			}
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			if (selectionKey != null) {
				SocketChannel client = (SocketChannel) selectionKey.channel();
				String ip = client.socket().getInetAddress().getHostAddress();
				System.out.println(ip + "离线了");
				client.socket().close();
				client.close();
				selectionKey.cancel();
			}
		}
	}

	/** 读取数据 **/
	protected void readBufer(SelectionKey selectionKey) throws IOException {
		// /////监听连接线程丢到读取线程///////////
		SocketChannel client = (SocketChannel) selectionKey.channel();
		ByteArrayOutputStream bos = (ByteArrayOutputStream) selectionKey
				.attachment();
		ByteBuffer buffer = ByteBuffer.allocate(10240);// 10kb缓存
		int actual = 0;
		while ((actual = client.read(buffer)) > 0) {
			buffer.flip();
			int limit = buffer.limit();
			byte b[] = new byte[limit];
			buffer.get(b);
			bos.write(b);
			buffer.clear();// 清空
		}
		if (actual < 0) {
			// 出现异常
			String ip = client.socket().getInetAddress().getHostAddress();
			System.out.println(ip + "数据读取异常,连接断开");
			client.socket().close();
			client.close();
			selectionKey.cancel();
			return;
		}
		ThreadPool.getInstance().execute(new SocketWriteThread(selectionKey));
	}

	public final Selector getSelector() {
		return selector;
	}

}
