package com.soft.nio.connector.socket;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.nio.ByteBuffer;
import java.nio.channels.SelectionKey;
import java.nio.channels.SocketChannel;

import com.soft.nio.connector.server.LogicPro;

public class SocketWriteThread implements Runnable {

	private SelectionKey sk;

	public SocketWriteThread(SelectionKey s) {
		sk = s;
	}

	public void run() {
		// TODO Auto-generated method stub
		try {
			writeBufer(sk);
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			System.out.println("写入关闭异常");
		}
	}

	/** 处理读取到数据和写入返回客户庙数据 **/
	protected void writeBufer(SelectionKey selectionKey) throws IOException {
		// /////写入数据////////
		SocketChannel client = null;
		try {
			client = (SocketChannel) selectionKey.channel();
			ByteArrayOutputStream stream = (ByteArrayOutputStream) selectionKey
					.attachment();
			stream.flush();

			// 预写入数据
			ByteArrayOutputStream arrayOutputStream = new ByteArrayOutputStream();
			DataOutputStream outputStream = new DataOutputStream(
					arrayOutputStream);
			// 预读取数据
			ByteArrayInputStream arrayInputStream = new ByteArrayInputStream(
					stream.toByteArray());
			DataInputStream inputStream = new DataInputStream(arrayInputStream);
			String name = LogicPro.class.getName();
			LogicPro logic = (LogicPro) Class.forName(name).newInstance();
			// 处理客户端读取到数据和服务端要发送的数据
			logic.processClientData(inputStream, outputStream, client.socket()
					.getInetAddress());
			inputStream.close();
			arrayInputStream.close();
			outputStream.flush();
			arrayOutputStream.flush();
			byte[] data = arrayOutputStream.toByteArray();
			outputStream.close();
			arrayOutputStream.close();

			ByteBuffer writeBuffer = ByteBuffer.wrap(data);
			while (writeBuffer.hasRemaining())
				client.write(writeBuffer);
			stream.reset();// 清空缓冲区，准备下次缓冲
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			if (client != null) {
				String ip = client.socket().getInetAddress().getHostAddress();
				System.out.println(ip + "数据写入异常,连接断开");
				client.socket().close();
				client.close();
			}
			selectionKey.cancel();
		}
	}
}